typedef enum{
  leftNeightbour,
  centerNeightbour,
  rightNeightbour
} neightbour_t;

// a struct of pixel indicies in each slice (   -8 - +7)*/
typedef struct{
  int topLeftNeightbour : 4;      //
  int topCenterNeightbour:4;
  int topRightNeightbour:4;
  int bottomLeftNeightbour:4;
  int bottomCenterNeightbour:4;
  int bottomRightNeightbour:4;
}neightbours_t;


neightbours_t neightbours[]={
  /* 0*/  { 7,  0,  1, -1, -1, -1},
  /* 1*/  { 1, -1,  2, -1, -1, -1},
  /* 2*/  { 2, -1,  3, -1, -1, -1},
  /* 3*/  { 3,  4, -1, -1, -1, -1},
  /* 4*/  { 5, -1,  6, -1, -1, -1},
  /* 5*/  { 6, -1,  7, -1, -1, -1},
  /*********************************/
  /* 0*/  { 7,  0,  1,  5,  0,  1},
  /* 1*/  { 0,  1,  2,  0, -1,  1},
  /* 2*/  { 1,  2,  3,  1, -1,  2},
  /* 3*/  { 2,  3,  4,  2, -1,  3},
  /* 4*/  { 3,  4,  5,  2,  3,  4},
  /* 5*/  { 4,  5,  6,  3, -1,  4},
  /* 6*/  { 5,  6,  7,  4, -1,  5},
  /* 7*/  { 6,  7,  0,  4,  5,  1},
  /*********************************/
  /* 0*/  {-1,  0, -1,  7,  0,  1},
  /* 1*/  { 0, -1,  1,  0,  1,  2},
  /* 2*/  { 1, -1,  2,  1,  2,  3},
  /* 3*/  { 2, -1,  3,  2,  3,  4},
  /* 4*/  {-1,  3, -1,  3,  4,  5},
  /* 5*/  { 3, -1,  4,  4,  5,  6},
  /* 6*/  { 4, -1,  5,  5,  6,  7},
  /* 7*/  { 5, -1,  0,  6,  7,  0},
  /*********************************/
  /* 0*/  { 0,  0,  0,  7,  0,  1},
  /* 1*/  { 0,  0,  0,  1, -1,  2},
  /* 2*/  { 0,  0,  0,  2, -1,  3},
  /* 3*/  { 0,  0,  0, -1,  4, -1},
  /* 4*/  { 0,  0,  0,  5, -1,  6},
  /* 5*/  { 0,  0,  0,  6, -1,  7},
  /*********************************/
  /* 0*/  {-1, -1, -1,  0,  2,  4},

};

int fadeNeighbours(unsigned long, void*);
int runningDots(unsigned long, void*);
int rainbowBands(unsigned long, void*);
int rainbowSpiral(unsigned long, void*);
int Fire2012(unsigned long, void*);
